<%

'###########################################################################
'#
'# Example ASP Script for Displaying a NESCafe ScreenShot from Web Browser
'#
'# @author  : David de Niese
'# @version : 0.57f
'#
'# The Screen Shots are saved in Native Format into screenshot folder
'#
'###########################################################################


'### Enable Explicit Variable Declaration

	Option Explicit


'### Force Expiring Responses

	Response.Expires=-1



'### Function to Return the Binary PNG Image Data

	Function imageData(filename)


		'### Turn On Error Handling

			On Error Resume Next


		'### Open the File which Contains the SaveRAM

			Dim fso
			Set fso = CreateObject("Scripting.FileSystemObject")

			Dim a
			Set a = fso.OpenTextFile(Server.MapPath(filename))


		'### Check for Errors

			If Err.Number <> 0 Then Response.End
			On Error Goto 0


		'### Declare Variables 

			Dim curline
			Dim ByteArray
			Dim I
			Dim MSB
			Dim LSB


		'### Loop Over the File and Broadcast the Data row at a time

			While Not a.AtEndOfLine 

				'### Read Line of Hex Pairs

					curline = a.readLine()


				'### Loop Through Each Hex Pair

					For I = 1 to Len(curline)/2

						'### Determine the Numeric Value of the Hex Pair

							MSB = Hex1ToDec(Mid(curline,I*2-1,1))
							LSB = Hex1ToDec(Mid(curline,I*2,1))


						'### Convert to Byte and Add to Byte Array

							ByteArray = ByteArray & ChrB(MSB*16+LSB)  

					Next

	
			Wend


		'### Close the File

			a.Close


		'### Return the Array of Bytes

			imageData = ByteArray 


	End Function



'### Function to Convert 1-digit Hex Value to Decimal

	Function Hex1ToDec(hexval)


		'### Declare Hex Array

			Dim HEX
			HEX = "0123456789ABCDEF"


		'### Convert to Decimal

			If instr(HEX,hexval) and Len(hexval) = 1 Then

				Hex1ToDec = Instr(HEX,hexval)-1
		
			Else

				Hex1ToDec = 0

			End If


	End Function

	


'#####################################################################################
'#
'# Main Routine
'#
'#####################################################################################


'### Turn Response Buffering On

	Response.Buffer = True


'### Set the ContentType to PNG

	Response.ContentType = "image/png"


'### Determine the Game Name from the Get Line (not the Post)

	Dim gamename
	gamename = Request("gamename")
	If gamename = "" Then gamename = "unknown"


'### Write the Binary PNG Data for the Cached Pixel Data

	Response.BinaryWrite imageData("screenshot\" & gamename & ".pixeldata")
	Response.End


%>