<%@ LANGUAGE="VBScript" %>
<%


'###########################################################################
'#
'# Example ASP Script for Loading Save RAM files into NESCafe Applet
'#
'# @author  : David de Niese
'# @version : 0.57f
'#
'# The Save RAM files are to be located from a subdirectory called saveram
'#
'###########################################################################


'### Enable Explicit Variable Declaration

	Option Explicit


'### Force Expiring Responses

	Response.Expires=-1


'### Grab the Game Name of the ROM File Loaded into NESCafe

	Dim gamename
	gamename = Request.Form("gamename")
	If gamename  = "" Then gamename = "unknown"


'### Turn on Error Recovery

	On Error Resume Next


'### Open the File which Contains the SaveRAM

	Dim fso
	Set fso = CreateObject("Scripting.FileSystemObject")

	Dim a
	Set a = fso.OpenTextFile(Server.MapPath("saveram\" & gamename & ".sav"))


'### Check for Errors

	If Err.Number <> 0 Then Response.End
	On Error Goto 0


'### Loop Over the File and Broadcast the Data row at a Time

	Dim curline

	While Not a.AtEndOfLine

		curline = a.readLine()
		Response.Write curline & Chr(13) & Chr(10)

	Wend


'### Close the File

	a.Close
	Response.End
	
%>